diff --git a/cmake/MakeExt.cmake b/cmake/MakeExt.cmake
index 5526601..cbfb20e 100644
--- a/cmake/MakeExt.cmake
+++ b/cmake/MakeExt.cmake
@@ -1,18 +1,18 @@
-#######################################################################
-#
-# pgAgent - PostgreSQL tools
-# Copyright (C) 2002 - 2016, The pgAdmin Development Team
-# This software is released under the PostgreSQL Licence
-#
-# MakeExt,cmake - Create the PG Extension
-#
-#######################################################################
-
-FILE(READ sql/pgagent.sql PGAGENT_SQL)
-STRING(REPLACE "BEGIN TRANSACTION;" "" PGAGENT_SQL "${PGAGENT_SQL}")
-STRING(REPLACE "COMMIT TRANSACTION;" "" PGAGENT_SQL "${PGAGENT_SQL}")
-STRING(REPLACE "CREATE SCHEMA pgagent;" "" PGAGENT_SQL "${PGAGENT_SQL}")
-STRING(REPLACE "-- EXT SELECT" "SELECT" PGAGENT_SQL "${PGAGENT_SQL}")
-FILE(WRITE "pgagent--${MAJOR_VERSION}.${MINOR_VERSION}.sql" "${PGAGENT_SQL}")
-
-CONFIGURE_FILE(pgagent.control.in pgagent.control)
+#######################################################################
+#
+# pgAgent - PostgreSQL tools
+# Copyright (C) 2002 - 2016, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+# MakeExt,cmake - Create the PG Extension
+#
+#######################################################################
+
+FILE(READ ${PGAGENT_SOURCE_DIR}/sql/pgagent.sql PGAGENT_SQL)
+STRING(REPLACE "BEGIN TRANSACTION;" "" PGAGENT_SQL "${PGAGENT_SQL}")
+STRING(REPLACE "COMMIT TRANSACTION;" "" PGAGENT_SQL "${PGAGENT_SQL}")
+STRING(REPLACE "CREATE SCHEMA pgagent;" "" PGAGENT_SQL "${PGAGENT_SQL}")
+STRING(REPLACE "-- EXT SELECT" "SELECT" PGAGENT_SQL "${PGAGENT_SQL}")
+FILE(WRITE "${CMAKE_BINARY_DIR}/pgagent--${MAJOR_VERSION}.${MINOR_VERSION}.sql" "${PGAGENT_SQL}")
+
+CONFIGURE_FILE(${PGAGENT_SOURCE_DIR}/pgagent.control.in ${CMAKE_BINARY_DIR}/pgagent.control)
diff --git a/connection.cpp b/connection.cpp
index 2b96294..e390af7 100644
--- a/connection.cpp
+++ b/connection.cpp
@@ -10,16 +10,50 @@
 //////////////////////////////////////////////////////////////////////////
 
 #include "pgAgent.h"
+#include <string>
 
-#include <wx/regex.h>
-#include <wx/tokenzr.h>
+namespace ip = boost::asio::ip;
 
-DBconn *DBconn::primaryConn = NULL;
-wxString DBconn::basicConnectString;
-static wxMutex s_PoolLock;
+DBconn *DBconn::ms_primaryConn = NULL;
+std::wstring DBconn::ms_basicConnectString;
+static boost::mutex s_poolLock;
 
+class MutexLocker
+{
+public:
+	MutexLocker(boost::mutex *lock): m_lock(lock)
+	{
+		if (m_lock)
+			m_lock->lock();
+	}
+
+	~MutexLocker()
+	{
+		if (m_lock)
+			m_lock->unlock();
+	}
+
+	// When the exit(code) is being called, static object is being released
+	// earlier. Hence - it is a good idea to set the current mutex object to
+	// NULL to avoid ASSERTION in debug mode (specifically on OSX).
+	MutexLocker& operator =(boost::mutex *lock)
+	{
+		if (m_lock)
+			m_lock->unlock();
+		m_lock = lock;
+
+		if (m_lock)
+			m_lock->lock();
 
-DBconn::DBconn(const wxString &connectString, const wxString &db)
+		return *this;
+	}
+
+private:
+	boost::mutex *m_lock;
+	bool is_locked;
+};
+
+DBconn::DBconn(const std::wstring &connectString, const std::wstring &db)
 {
 	inUse = false;
 	next = 0;
@@ -29,11 +63,11 @@ DBconn::DBconn(const wxString &connectString, const wxString &db)
 	dbname = db;
 	connStr = connectString;
 
-	if (connectString.IsEmpty())
+	if (connectString.empty())
 	{
 		// This is a sql call to a local database.
 		// No connection string found. Use basicConnectString.
-		Connect(basicConnectString  + wxT(" dbname=") + dbname);
+		Connect(ms_basicConnectString + L" dbname=" + dbname);
 	}
 	else
 	{
@@ -42,17 +76,23 @@ DBconn::DBconn(const wxString &connectString, const wxString &db)
 }
 
 
-bool DBconn::Connect(const wxString &connectString)
+bool DBconn::Connect(const std::wstring &connectString)
 {
-	LogMessage(wxString::Format(_("Creating DB connection: %s"), connectString.c_str()), LOG_DEBUG);
-	wxCharBuffer cstrUTF = connectString.mb_str(wxConvUTF8);
-	conn = PQconnectdb(cstrUTF);
-	if (PQstatus(conn) != CONNECTION_OK)
+	LogMessage((L"Creating DB connection: " + connectString), LOG_DEBUG);
+	char *cstrUTF = WStringToChar(connectString);
+	if (cstrUTF != NULL)
 	{
-		lastError = wxString::FromAscii(PQerrorMessage(conn));
-		PQfinish(conn);
-		conn = 0;
+		conn = PQconnectdb(cstrUTF);
+		if (PQstatus(conn) != CONNECTION_OK)
+		{
+			lastError = CharToWString((const char *)PQerrorMessage(conn));
+			PQfinish(conn);
+			conn = 0;
+		}
+
+		delete [] cstrUTF;
 	}
+
 	return IsValid();
 }
 
@@ -68,118 +108,139 @@ DBconn::~DBconn()
 }
 
 
-wxString DBconn::qtDbString(const wxString &value)
+std::wstring DBconn::qtDbString(const std::wstring &value)
 {
-	wxString result = value;
+	std::wstring result = value;
 
-	result.Replace(wxT("\\"), wxT("\\\\"));
-	result.Replace(wxT("'"), wxT("''"));
-	result.Append(wxT("'"));
+	boost::replace_all(result, L"\\", L"\\\\");
+	boost::replace_all(result, L"'", L"''");
+	result.append(L"'");
 
 	if (BackendMinimumVersion(8, 1))
 	{
-		if (result.Contains(wxT("\\")))
-			result.Prepend(wxT("E'"));
+		if (result.find(L"\\") != std::wstring::npos)
+			result.replace(0, 0, L"E'");
 		else
-			result.Prepend(wxT("'"));
+			result.replace(0, 0, L"'");
 	}
 	else
-		result.Prepend(wxT("'"));
+		result.replace(0, 0, L"'");
 
 	return result;
 }
 
-
 bool DBconn::BackendMinimumVersion(int major, int minor)
 {
+	char *ver = NULL;
 	if (!majorVersion)
 	{
-		wxString version = ExecuteScalar(wxT("SELECT version();")) ;
-		sscanf(version.ToAscii(), "%*s %d.%d", &majorVersion, &minorVersion);
+		std::wstring version = ExecuteScalar(L"SELECT version();");
+		ver = WStringToChar(version);
+		if (ver != NULL)
+			sscanf(ver, "%*s %d.%d", &majorVersion, &minorVersion);
 	}
+
+	if (ver != NULL)
+		delete []ver;
+
 	return majorVersion > major || (majorVersion == major && minorVersion >= minor);
 }
 
 
-DBconn *DBconn::InitConnection(const wxString &connectString)
+DBconn *DBconn::InitConnection(const std::wstring &connectString)
 {
-	wxMutexLocker lock(s_PoolLock);
+	MutexLocker locker(&s_poolLock);
 
-	basicConnectString = connectString;
-	wxString dbname;
+	ms_basicConnectString = connectString;
+	std::wstring dbname;
 
 	connInfo cnInfo = connInfo::getConnectionInfo(connectString);
 	if (cnInfo.isValid)
 	{
 		dbname = cnInfo.dbname;
-		basicConnectString = cnInfo.getConnectionString();
-		primaryConn = new DBconn(cnInfo.getConnectionString(), dbname);
+		ms_basicConnectString = cnInfo.getConnectionString();
+		ms_primaryConn = new DBconn(cnInfo.getConnectionString(), dbname);
 
-		if (!primaryConn)
-			LogMessage(_("Failed to create primary connection!"), LOG_ERROR);
-		primaryConn->dbname = dbname;
-		primaryConn->inUse = true;
+		if (!ms_primaryConn)
+		{
+			// Unlock the mutex before logging error.
+			locker = (boost::mutex *)NULL;
+			LogMessage(L"Failed to create primary connection!", LOG_ERROR);
+		}
+		if (!ms_primaryConn->IsValid())
+		{
+			std::wstring error = ms_primaryConn->GetLastError();
+			delete ms_primaryConn;
+			ms_primaryConn = NULL;
+			// Unlock the mutex before logging error.
+			locker = (boost::mutex *)NULL;
+			LogMessage(
+				L"Failed to create primary connection: " + error, LOG_ERROR
+				);
+		}
+		ms_primaryConn->dbname = dbname;
+		ms_primaryConn->inUse = true;
 	}
 	else
 	{
-		primaryConn = NULL;
-		LogMessage(wxT("Primary connection string is not valid!"), LOG_ERROR);
+		ms_primaryConn = NULL;
+		// Unlock the mutex before logging error.
+		locker = (boost::mutex *)NULL;
+		LogMessage(L"Primary connection string is not valid!", LOG_ERROR);
 	}
 
-	return primaryConn;
+	return ms_primaryConn;
 }
 
 
-DBconn *DBconn::Get(const wxString &connStr, const wxString &db)
+DBconn *DBconn::Get(const std::wstring &connStr, const std::wstring &db)
 {
-	if (db.IsEmpty() && connStr.IsEmpty())
+	if (db.empty() && connStr.empty())
 	{
-		LogMessage(_("Cannot allocate connection - no database or connection string specified!"), LOG_WARNING);
+		LogMessage(L"Cannot allocate connection - no database or connection string specified!", LOG_WARNING);
 		return NULL;
 	}
+	MutexLocker locker(&s_poolLock);
 
-	wxMutexLocker lock(s_PoolLock);
-
-	DBconn *thisConn = primaryConn, *lastConn;
+	DBconn *thisConn = ms_primaryConn, *lastConn;
 
 	// find an existing connection
 	do
 	{
-		if (thisConn && ((!db.IsEmpty() && db == thisConn->dbname && connStr.IsEmpty()) || (!connStr.IsEmpty() && connStr == thisConn->connStr)) && !thisConn->inUse)
+		if (thisConn && ((!db.empty() && db == thisConn->dbname && connStr.empty()) || (!connStr.empty() && connStr == thisConn->connStr)) && !thisConn->inUse)
 		{
-			LogMessage(wxString::Format(_("Allocating existing connection to database %s"), thisConn->dbname.c_str()), LOG_DEBUG);
+			LogMessage((L"Allocating existing connection to database " + thisConn->dbname), LOG_DEBUG);
 			thisConn->inUse = true;
+
 			return thisConn;
 		}
 
 		lastConn = thisConn;
 		thisConn = thisConn->next;
 
-	}
-	while (thisConn != 0);
+	} while (thisConn != 0);
 
 
 	// No suitable connection was found, so create a new one.
 	DBconn *newConn = NULL;
 	newConn = new DBconn(connStr, db);
 
-	if (newConn->conn)
+	if (newConn && newConn->conn)
 	{
-		LogMessage(wxString::Format(_("Allocating new connection to database %s"), newConn->dbname.c_str()), LOG_DEBUG);
+		LogMessage((L"Allocating new connection to database " + newConn->dbname), LOG_DEBUG);
 		newConn->inUse = true;
 		newConn->prev = lastConn;
 		lastConn->next = newConn;
 	}
 	else
 	{
-		wxString warnMsg;
-		if (connStr.IsEmpty())
-			warnMsg = wxString::Format(_("Failed to create new connection to database '%s':'%s'"),
-			                           db.c_str(), newConn->GetLastError().c_str());
+		std::wstring warnMsg;
+		if (connStr.empty())
+			warnMsg = (L"Failed to create new connection to database '" + db + L"':'" + newConn->GetLastError() + L"'");
 		else
-			warnMsg = wxString::Format(_("Failed to create new connection for connection string '%s':%s"),
-			                           connStr.c_str(), newConn->GetLastError().c_str());
+			warnMsg = (L"Failed to create new connection for connection string '" + connStr + L"':'" + newConn->GetLastError() + L"'");
 		LogMessage(warnMsg, LOG_STARTUP);
+
 		return NULL;
 	}
 
@@ -189,27 +250,27 @@ DBconn *DBconn::Get(const wxString &connStr, const wxString &db)
 
 void DBconn::Return()
 {
-	wxMutexLocker lock(s_PoolLock);
+	MutexLocker locker(&s_poolLock);
 
 	// Cleanup
-	this->ExecuteVoid(wxT("RESET ALL"));
-	this->lastError.Empty();
+	this->ExecuteVoid(L"RESET ALL");
+	this->lastError.empty();
 
-	LogMessage(wxString::Format(_("Returning connection to database %s"), dbname.c_str()), LOG_DEBUG);
+	LogMessage((L"Returning connection to database " + dbname), LOG_DEBUG);
 	inUse = false;
 }
 
 
 void DBconn::ClearConnections(bool all)
 {
-	wxMutexLocker lock(s_PoolLock);
+	MutexLocker locker(&s_poolLock);
 
 	if (all)
-		LogMessage(_("Clearing all connections"), LOG_DEBUG);
+		LogMessage(L"Clearing all connections", LOG_DEBUG);
 	else
-		LogMessage(_("Clearing inactive connections"), LOG_DEBUG);
+		LogMessage(L"Clearing inactive connections", LOG_DEBUG);
 
-	DBconn *thisConn = primaryConn, *deleteConn;
+	DBconn *thisConn = ms_primaryConn, *deleteConn;
 	int total = 0, free = 0, deleted = 0;
 
 	if (thisConn)
@@ -254,21 +315,19 @@ void DBconn::ClearConnections(bool all)
 		if (all)
 		{
 			delete thisConn;
+			ms_primaryConn = NULL;
 			deleted++;
 		}
 
-		wxString tmp;
-		tmp.Printf(_("Connection stats: total - %d, free - %d, deleted - %d"), total, free, deleted);
-		LogMessage(tmp, LOG_DEBUG);
+		LogMessage((boost::wformat(L"Connection stats: total - %d, free - %d, deleted - %d") % total % free % deleted).str(), LOG_DEBUG);
 
 	}
 	else
-		LogMessage(_("No connections found!"), LOG_DEBUG);
-
+		LogMessage(L"No connections found!", LOG_DEBUG);
 }
 
 
-DBresult *DBconn::Execute(const wxString &query)
+DBresult *DBconn::Execute(const std::wstring &query)
 {
 	DBresult *res = new DBresult(this, query);
 	if (!res->IsValid())
@@ -282,66 +341,70 @@ DBresult *DBconn::Execute(const wxString &query)
 }
 
 
-wxString DBconn::ExecuteScalar(const wxString &query)
+std::wstring DBconn::ExecuteScalar(const std::wstring &query)
 {
 	int rows = -1;
-	DBresult *res = Execute(query);
-	wxString data;
+	DBresultPtr res = Execute(query);
+	std::wstring data;
 	if (res)
 	{
 		data = res->GetString(0);
 		rows = res->RowsAffected();
-		delete res;
 		return data;
 	}
-	return wxEmptyString;
+	return L"";
 }
 
 
-int DBconn::ExecuteVoid(const wxString &query)
+int DBconn::ExecuteVoid(const std::wstring &query)
 {
 	int rows = -1;
-	DBresult *res = Execute(query);
+	DBresultPtr res = Execute(query);
 	if (res)
 	{
 		rows = res->RowsAffected();
-		delete res;
 	}
 	return rows;
 }
 
 
-wxString DBconn::GetLastError()
+std::wstring DBconn::GetLastError()
 {
-	return lastError.Trim(true);
+	boost::algorithm::trim(lastError);
+	return lastError;
 }
 
 ///////////////////////////////////////////////////////7
 
-DBresult::DBresult(DBconn *conn, const wxString &query)
+DBresult::DBresult(DBconn *conn, const std::wstring &query)
 {
-	wxCharBuffer cstrUTF = query.mb_str(wxConvUTF8);
-	result = PQexec(conn->conn, cstrUTF);
+	char *cstrUTF = WStringToChar(query);
 	currentRow = 0;
 	maxRows = 0;
-
-	if (result)
+	if (cstrUTF != NULL)
 	{
-		int rc = PQresultStatus(result);
-		conn->SetLastResult(rc);
-		if (rc == PGRES_TUPLES_OK)
-			maxRows = PQntuples(result);
-		else if (rc != PGRES_COMMAND_OK)
+		result = PQexec(conn->conn, cstrUTF);
+
+		if (result)
 		{
-			conn->lastError = wxString::FromAscii(PQerrorMessage(conn->conn));
-			LogMessage(wxT("Query error: ") + conn->lastError, LOG_WARNING);
-			PQclear(result);
-			result = 0;
+			int rc = PQresultStatus(result);
+			conn->SetLastResult(rc);
+			if (rc == PGRES_TUPLES_OK)
+				maxRows = PQntuples(result);
+			else if (rc != PGRES_COMMAND_OK)
+			{
+				const char *last_error = PQerrorMessage(conn->conn);
+				conn->lastError = CharToWString(last_error);
+				LogMessage((L"Query error: " + conn->lastError), LOG_WARNING);
+				PQclear(result);
+				result = 0;
+			}
 		}
-	}
-	else
-		conn->lastError = wxString::FromAscii(PQerrorMessage(conn->conn));
+		else
+			conn->lastError = CharToWString(PQerrorMessage(conn->conn));
 
+		delete [] cstrUTF;
+	}
 }
 
 
@@ -352,26 +415,31 @@ DBresult::~DBresult()
 }
 
 
-wxString DBresult::GetString(int col) const
+std::wstring DBresult::GetString(int col) const
 {
-	wxString str;
+	std::wstring str;
 
 	if (result && currentRow < maxRows && col >= 0)
 	{
-		str = wxString::FromAscii(PQgetvalue(result, currentRow, col));
+		str = CharToWString((const char *)PQgetvalue(result, currentRow, col));
 	}
 	return str;
 }
 
 
-wxString DBresult::GetString(const wxString &colname) const
+std::wstring DBresult::GetString(const std::wstring &colname) const
 {
-	wxCharBuffer cstrUTF = colname.mb_str(wxConvUTF8);
+	char *cstrUTF = WStringToChar(colname);
+
+	// Below function will return -1 if string is NULL or does not match.
 	int col = PQfnumber(result, cstrUTF);
+	if (cstrUTF != NULL)
+		delete [] cstrUTF;
+
 	if (col < 0)
 	{
 		// fatal: not found
-		return wxT("");
+		return L"";
 	}
 	return GetString(col);
 }
@@ -380,170 +448,138 @@ wxString DBresult::GetString(const wxString &colname) const
 
 bool connInfo::IsValidIP()
 {
-	if (host.IsEmpty())
+	if (host.empty())
 		return false;
 
-	// check for IPv4 format
-	wxStringTokenizer tkip4(host, wxT("."));
-	int count = 0;
-
-	while (tkip4.HasMoreTokens())
+	const std::string hostAddr(host.begin(), host.end());
+	try
 	{
-		long val = 0;
-		if (!tkip4.GetNextToken().ToLong(&val))
-			break;
-		if (count == 0 || count == 3)
-			if (val > 0 && val < 255)
-				count++;
-			else
-				break;
-		else if (val >= 0 && val < 255)
-			count++;
-		else
-			break;
+		ip::address ip = ip::address::from_string(hostAddr);
+		if (ip.is_v4() || ip.is_v6())
+			return true;
 	}
-
-	if (count == 4)
-		return true;
-
-	// check for IPv6 format
-	wxStringTokenizer tkip6(host, wxT(":"));
-	count = 0;
-
-	while (tkip6.HasMoreTokens())
+	catch (const boost::system::system_error& e)
 	{
-		unsigned long val = 0;
-		wxString strVal = tkip6.GetNextToken();
-		if (strVal.Length() > 4 || !strVal.ToULong(&val, 16))
-			return false;
-		count++;
+		LogMessage(CharToWString((const char *)e.what()), LOG_WARNING);
+		return false;
 	}
-	if (count <= 8)
-		return true;
 
-	// TODO:: We're not supporting mix mode (x:x:x:x:x:x:d.d.d.d)
-	//        i.e. ::ffff:12.34.56.78
 	return false;
 }
 
-
-wxString connInfo::getConnectionString()
+std::wstring connInfo::getConnectionString()
 {
-	wxString connStr;
+	std::wstring connStr;
 
 	// Check if it has valid connection info
 	if (!isValid)
 		return connStr;
 
 	// User
-	connStr = wxT("user=") + user;
+	connStr = L"user=" + user;
 
 	// Port
 	if (port != 0)
 	{
-		wxString portStr;
-		portStr.Printf(wxT("%ld"), port);
-		connStr += wxT(" port=") + portStr;
+		std::wstring portStr(boost::lexical_cast<std::wstring>(port));
+		connStr += L" port=" + portStr;
 	}
 
 	// host or hostaddr
-	if (!host.IsEmpty())
+	if (!host.empty())
 	{
 		if (IsValidIP())
-			connStr += wxT(" hostaddr=") + host;
+			connStr += L" hostaddr=" + host;
 		else
-			connStr += wxT(" host=") + host;
+			connStr += L" host=" + host;
 	}
 
 	// connection timeout
 	if (connection_timeout != 0)
 	{
-		wxString val;
-		val.Printf(wxT("%ld"), connection_timeout);
-		connStr += wxT(" connection_timeout=") + val;
+		std::wstring val(boost::lexical_cast<std::wstring>(connection_timeout));
+		connStr += L" connection_timeout=" + val;
 	}
 
 	// password
-	if (!password.IsEmpty())
-		connStr += wxT(" password=") + password;
+	if (!password.empty())
+		connStr += L" password=" + password;
+
+	if (!dbname.empty())
+		connStr += L" dbname=" + dbname;
 
-	if (!dbname.IsEmpty())
-		connStr += wxT(" dbname=") + dbname;
+	LogMessage(L"Connection Information:", LOG_DEBUG);
 
-	LogMessage(wxString::Format(_("Connection Information:")), LOG_DEBUG);
-	LogMessage(wxString::Format(_("     user         : %s"), user.c_str()), LOG_DEBUG);
-	LogMessage(wxString::Format(_("     port         : %ld"), port), LOG_DEBUG);
-	LogMessage(wxString::Format(_("     host         : %s"), host.c_str()), LOG_DEBUG);
-	LogMessage(wxString::Format(_("     dbname       : %s"), dbname.c_str()), LOG_DEBUG);
-	LogMessage(wxString::Format(_("     password     : %s"), password.c_str()), LOG_DEBUG);
-	LogMessage(wxString::Format(_("     conn timeout : %ld"), connection_timeout), LOG_DEBUG);
+	LogMessage((L"     user         : " + user), LOG_DEBUG);
+	LogMessage((boost::wformat(L"     port         : %d") % port).str(), LOG_DEBUG);
+	LogMessage((L"     host         : " + host), LOG_DEBUG);
+	LogMessage((L"     dbname       : " + dbname), LOG_DEBUG);
+	LogMessage((L"     password     : " + password), LOG_DEBUG);
+	LogMessage((boost::wformat(L"     conn timeout : %d") % connection_timeout).str(), LOG_DEBUG);
 
 	return connStr;
 }
 
-
-connInfo connInfo::getConnectionInfo(wxString connStr)
+connInfo connInfo::getConnectionInfo(const std::wstring &conn_str)
 {
 	connInfo cnInfo;
 
-	wxRegEx propertyExp;
-
-	// Remove the white-space(s) to match the following format
-	// i.e. prop=value
-	bool res = propertyExp.Compile(wxT("(([ ]*[\t]*)+)="));
+	std::string connStr(conn_str.begin(), conn_str.end());
 
-	propertyExp.ReplaceAll(&connStr, wxT("="));
+	const boost::regex propertyExp("(([ ]*[\t]*)+)=");
+	connStr = boost::regex_replace(connStr, propertyExp, std::string("="));
 
-	res = propertyExp.Compile(wxT("=(([ ]*[\t]*)+)"));
-	propertyExp.ReplaceAll(&connStr, wxT("="));
+	const boost::regex propertyExp_("=(([ ]*[\t]*)+)");
+	connStr = boost::regex_replace(connStr, propertyExp_, std::string("="));
 
-	// Seperate all the prop=value patterns
-	wxArrayString tokens = wxStringTokenize(connStr, wxT("\t \n\r"));
+	boost::char_separator<char> sep("\t \n\r");
+	boost::tokenizer<boost::char_separator<char> > tok(connStr, sep);
 
-	unsigned int index = 0;
-	while (index < tokens.Count())
+	for (boost::tokenizer< boost::char_separator<char> >::iterator beg = tok.begin(); (beg != tok.end()); ++beg)
 	{
-		wxString prop, value;
+		std::wstring prop, value;
+		int key_val_pair = 0;
 
-		wxArrayString pairs = wxStringTokenize(tokens[index++], wxT("="));
+		boost::char_separator<char> sep_("=");
+		boost::tokenizer<boost::char_separator<char> > tok_(*beg, sep_);
 
-		if (pairs.GetCount() != 2)
-			return cnInfo;
+		for (boost::tokenizer< boost::char_separator<char> >::iterator key_val = tok_.begin(); (key_val != tok_.end()); ++key_val)
+		{
+			std::string tk = *key_val;
+			if (key_val_pair)
+				value = std::wstring(tk.begin(), tk.end());
+			else
+				prop = std::wstring(tk.begin(), tk.end());
+			key_val_pair++;
+		}
 
-		prop = pairs[0];
-		value = pairs[1];
+		if (key_val_pair != 2)
+			return cnInfo;
 
-		if (prop.CmpNoCase(wxT("user")) == 0)
+		if (boost::iequals(prop, L"user"))
 			cnInfo.user = value;
-		else if (prop.CmpNoCase(wxT("host")) == 0 || prop.CmpNoCase(wxT("hostAddr")) == 0)
+		else if (boost::iequals(prop, L"host") || boost::iequals(prop, L"hostAddr"))
 			cnInfo.host = value;
-		else if (prop.CmpNoCase(wxT("port")) == 0)
-		{
-			if (!value.ToULong(&cnInfo.port))
-				// port must be an unsigned integer
-				return cnInfo;
-		}
-		else if (prop.CmpNoCase(wxT("password")) == 0)
+		else if (boost::iequals(prop, L"port"))
+			cnInfo.port = boost::lexical_cast<unsigned long>(value);
+		else if (boost::iequals(prop, L"password"))
 			cnInfo.password = value;
-		else if (prop.CmpNoCase(wxT("connection_timeout")) == 0)
-		{
-			if (!value.ToULong(&cnInfo.connection_timeout))
-				// connection timeout must be an unsigned interger
-				return cnInfo;
-		}
-		else if (prop.CmpNoCase(wxT("dbname")) == 0)
+		else if (boost::iequals(prop, L"connection_timeout"))
+			cnInfo.connection_timeout = boost::lexical_cast<unsigned long>(value);
+		else if (boost::iequals(prop, L"dbname"))
 			cnInfo.dbname = value;
 		else
+		{
 			// Not valid property found
 			return cnInfo;
+		}
 	}
 
 	// If user, dbname & host all are blank than we will consider this an invalid connection string
-	if (cnInfo.user.IsEmpty() && cnInfo.dbname.IsEmpty() && cnInfo.host.IsEmpty())
+	if (cnInfo.user.empty() && cnInfo.dbname.empty() && cnInfo.host.empty())
 		cnInfo.isValid = false;
 	else
 		cnInfo.isValid = true;
 
 	return cnInfo;
 }
-
diff --git a/include/connection.h b/include/connection.h
index b2693f7..5ba4362 100644
--- a/include/connection.h
+++ b/include/connection.h
@@ -21,29 +21,29 @@ class DBresult;
 class DBconn
 {
 protected:
-	DBconn(const wxString &, const wxString &);
+	DBconn(const std::wstring &, const std::wstring &);
 	~DBconn();
 
 public:
-	wxString qtDbString(const wxString &value);
+	std::wstring qtDbString(const std::wstring &value);
 
 	bool BackendMinimumVersion(int major, int minor);
 
-	static DBconn *Get(const wxString &connStr, const wxString &db);
-	static DBconn *InitConnection(const wxString &connectString);
+	static DBconn *Get(const std::wstring &connStr, const std::wstring &db);
+	static DBconn *InitConnection(const std::wstring &connectString);
 
 	static void ClearConnections(bool allIncludingPrimary = false);
-	static void SetBasicConnectString(const wxString &bcs)
+	static void SetBasicConnectString(const std::wstring &bcs)
 	{
-		basicConnectString = bcs;
+		ms_basicConnectString = bcs;
 	}
-	static const wxString &GetBasicConnectString()
+	static const std::wstring &GetBasicConnectString()
 	{
-		return basicConnectString;
+		return ms_basicConnectString;
 	}
 
-	wxString GetLastError();
-	wxString GetDBname()
+	std::wstring GetLastError();
+	std::wstring GetDBname()
 	{
 		return dbname;
 	}
@@ -53,53 +53,53 @@ public:
 		return conn != 0;
 	}
 
-        bool LastCommandOk()
-        {
-                return IsCommandOk((ExecStatusType)lastResult);
-        }
+	bool LastCommandOk()
+	{
+		return IsCommandOk((ExecStatusType)lastResult);
+	}
 
-        bool IsCommandOk(ExecStatusType ret)
-        {
-                switch (ret)
-                {
-                        case PGRES_COMMAND_OK:
-                        case PGRES_TUPLES_OK:
-                        case PGRES_COPY_OUT:
-                        case PGRES_COPY_IN:
+	bool IsCommandOk(ExecStatusType ret)
+	{
+		switch (ret)
+		{
+			case PGRES_COMMAND_OK:
+			case PGRES_TUPLES_OK:
+			case PGRES_COPY_OUT:
+			case PGRES_COPY_IN:
 #if (PG_VERSION_NUM >= 90100)
-                        case PGRES_COPY_BOTH:
+			case PGRES_COPY_BOTH:
 #endif
-                                return true;
-                        default:
-                                return false;
-                };
-        }
-
-        void SetLastResult(int res)
-        {
-                lastResult = res;
-        }
-
-        int GetLastResult()
-        {
-                return lastResult;
-        }
-	
-	DBresult *Execute(const wxString &query);
-	wxString ExecuteScalar(const wxString &query);
-	int ExecuteVoid(const wxString &query);
+				return true;
+			default:
+				return false;
+		};
+	}
+
+	void SetLastResult(int res)
+	{
+		lastResult = res;
+	}
+
+	int GetLastResult()
+	{
+		return lastResult;
+	}
+
+	DBresult *Execute(const std::wstring &query);
+	std::wstring ExecuteScalar(const std::wstring &query);
+	int ExecuteVoid(const std::wstring &query);
 	void Return();
 
 private:
-	bool Connect(const wxString &connectString);
+	bool Connect(const std::wstring &connectString);
 
 	int minorVersion, majorVersion;
 
 protected:
-	static wxString basicConnectString;
-	static DBconn *primaryConn;
+	static std::wstring ms_basicConnectString;
+	static DBconn *ms_primaryConn;
 
-	wxString dbname, lastError, connStr;
+	std::wstring dbname, lastError, connStr;
 	PGconn *conn;
 	DBconn *next, *prev;
 	bool inUse;
@@ -112,13 +112,13 @@ protected:
 class DBresult
 {
 protected:
-	DBresult(DBconn *conn, const wxString &query);
+	DBresult(DBconn *conn, const std::wstring &query);
 
 public:
 	~DBresult();
 
-	wxString GetString(int col) const;
-	wxString GetString(const wxString &colname) const;
+	std::wstring GetString(int col) const;
+	std::wstring GetString(const std::wstring &colname) const;
 
 	bool IsValid() const
 	{
@@ -146,6 +146,54 @@ protected:
 };
 
 
+class DBresultPtr
+{
+public:
+	DBresultPtr(DBresult* in_ptr)
+		: m_ptr(in_ptr)
+	{}
+	~DBresultPtr()
+	{
+		if (m_ptr) {
+			delete m_ptr;
+			m_ptr = NULL;
+		}
+	}
+	DBresultPtr& operator=(DBresult *other)
+	{
+		if (m_ptr) {
+			delete m_ptr;
+		}
+		m_ptr = other;
+		return *this;
+	}
+	const DBresult& operator*() const
+	{
+		return (*(const DBresult *)m_ptr);
+	}
+	const DBresult* operator->() const
+	{
+		return (const DBresult*)(m_ptr);
+	}
+	DBresult& operator*()
+	{
+		return (*(DBresult *)m_ptr);
+	}
+	DBresult* operator->()
+	{
+		return (DBresult *)m_ptr;
+	}
+	operator void*() const
+	{
+		return (DBresult *)m_ptr;
+	}
+	operator bool() const { return (m_ptr != NULL); }
+
+protected:
+	DBresult* m_ptr;
+};
+
+
 class connInfo
 {
 public:
@@ -157,16 +205,16 @@ public:
 	}
 
 private:
-	wxString      user;
+	std::wstring  user;
 	unsigned long port;
-	wxString      host;
-	wxString      dbname;
+	std::wstring  host;
+	std::wstring  dbname;
 	unsigned long connection_timeout;
-	wxString      password;
+	std::wstring  password;
 	bool          isValid;
 
-	wxString getConnectionString();
-	static connInfo getConnectionInfo(wxString connStr);
+	std::wstring getConnectionString();
+	static connInfo getConnectionInfo(const std::wstring &connStr);
 
 protected:
 	bool IsValidIP();
diff --git a/include/job.h b/include/job.h
index 1e1beb7..eae32b3 100644
--- a/include/job.h
+++ b/include/job.h
@@ -13,44 +13,35 @@
 #ifndef JOB_H
 #define JOB_H
 
-#include <wx/wx.h>
-
+#include <boost/thread.hpp>
 
 class Job
 {
 public:
-	Job(DBconn *conn, const wxString &jid);
+	Job(DBconn *conn, const std::wstring &jid);
 	~Job();
 
 	int Execute();
 	bool Runnable()
 	{
-		return status == wxT("r");
+		return status == L"r";
 	}
 
 protected:
 	DBconn *threadConn;
-	wxString jobid, logid;
-	wxString status;
+	std::wstring jobid, logid;
+	std::wstring status;
 };
 
-
-class JobThread : public wxThread
+class JobThread
 {
 public:
-	JobThread(const wxString &jid);
+	JobThread(const std::wstring &jid);
 	~JobThread();
-	bool Runnable()
-	{
-		return runnable;
-	}
-
-	virtual void *Entry();
+	void operator()();
 
 private:
-	wxString jobid;
-	bool runnable;
-	Job *job;
+	std::wstring  m_jobid;
 };
 
 #endif // JOB_H
diff --git a/include/misc.h b/include/misc.h
index cc849e5..83e5c80 100644
--- a/include/misc.h
+++ b/include/misc.h
@@ -15,10 +15,14 @@
 
 
 void WaitAWhile(const bool waitLong = false);
-void setOptions(int argc, char **argv, const wxString &executable);
-wxString getArg(int &argc, char **&argv);
-wxString NumToStr(const long l);
+void setOptions(int argc, char **argv, const std::wstring &executable);
+std::wstring getArg(int &argc, char **&argv);
+std::wstring NumToStr(const long l);
 void printVersion();
+std::wstring CharToWString(const char* cstr);
+char* WStringToChar(const std::wstring &wstr);
+std::string generateRandomString(size_t length);
+std::wstring getTemporaryDirectoryPath();
 
 #endif // MISC_H
 
diff --git a/include/pgAgent.h b/include/pgAgent.h
index be29dcb..69e801e 100644
--- a/include/pgAgent.h
+++ b/include/pgAgent.h
@@ -13,10 +13,24 @@
 #ifndef PGAGENT_H
 #define PGAGENT_H
 
-// Disable all the GUI classes that might get pulled in through the headers
-#define wxUSE_GUI 0
+#if BOOST_OS_WINDOWS
+#include <windows.h>
+#endif
 
-#include <wx/wx.h>
+#include <boost/asio.hpp>
+#include <boost/format.hpp>
+#include <boost/thread/mutex.hpp>
+#include <boost/regex.hpp>
+#include <boost/lexical_cast.hpp>
+#include <boost/tokenizer.hpp>
+#include <boost/algorithm/string/replace.hpp>
+#include <boost/algorithm/string/trim.hpp>
+#include <boost/algorithm/string/predicate.hpp>
+#include <boost/filesystem.hpp>
+#include <boost/filesystem/fstream.hpp>
+#include <boost/date_time/gregorian/gregorian.hpp>
+#include <boost/date_time/gregorian/gregorian_types.hpp>
+#include <boost/date_time/posix_time/posix_time.hpp>
 
 #include "misc.h"
 #include "connection.h"
@@ -25,13 +39,13 @@
 extern long longWait;
 extern long shortWait;
 extern long minLogLevel;
-extern wxString connectString;
-extern wxString serviceDBname;
-extern wxString backendPid;
+extern std::wstring connectString;
+extern std::wstring serviceDBname;
+extern std::wstring backendPid;
 
-#ifndef __WXMSW__
+#if !BOOST_OS_WINDOWS
 extern bool runInForeground;
-extern wxString logFile;
+extern std::wstring logFile;
 #endif
 
 // Log levels
@@ -48,13 +62,12 @@ enum
 };
 
 // Prototypes
-void LogMessage(wxString msg, int level);
+void LogMessage(const std::wstring &msg, const int &level);
 void MainLoop();
 
-#ifdef __WIN32__
-#include <windows.h>
+#if BOOST_OS_WINDOWS
 void CheckForInterrupt();
-HANDLE win32_popen_r(const TCHAR *command, HANDLE &handle);
+HANDLE win32_popen_r(const WCHAR *command, HANDLE &handle);
 #endif
 
 #endif // PGAGENT_H
